From 0aa8214ae954456844bd164b43023953f803f09d Mon Sep 17 00:00:00 2001
From: John Crispin <john@openwrt.org>
Date: Fri, 22 Aug 2014 19:02:30 +0000
Subject: [PATCH] umbim: add netifd proto handler for mbim style lte modems

tested on vodafone k5105

Signed-off-by: John Crispin <blogic@openwrt.org>

SVN-Revision: 42262
---
 package/network/utils/umbim/Makefile          |  45 ++++++
 .../umbim/files/lib/netifd/proto/mbim.sh      | 147 ++++++++++++++++++
 2 files changed, 192 insertions(+)
 create mode 100644 package/network/utils/umbim/Makefile
 create mode 100755 package/network/utils/umbim/files/lib/netifd/proto/mbim.sh

diff --git a/package/network/utils/umbim/Makefile b/package/network/utils/umbim/Makefile
new file mode 100644
index 0000000000..a660f88bcb
--- /dev/null
+++ b/package/network/utils/umbim/Makefile
@@ -0,0 +1,45 @@
+include $(TOPDIR)/rules.mk
+
+PKG_NAME:=umbim
+PKG_VERSION:=2014-08-22
+PKG_RELEASE=$(PKG_SOURCE_VERSION)
+
+PKG_SOURCE_PROTO:=git
+PKG_SOURCE_URL:=git://git.openwrt.org/project/umbim.git
+PKG_SOURCE_SUBDIR:=$(PKG_NAME)-$(PKG_VERSION)
+PKG_SOURCE_VERSION:=b82f187ab204a56f5ed7cd6d4de64bfdc07a1a74
+PKG_SOURCE:=$(PKG_NAME)-$(PKG_VERSION)-$(PKG_SOURCE_VERSION).tar.gz
+PKG_MAINTAINER:=John Crispin <blogic@openwrt.org>
+
+PKG_LICENSE:=GPLv2
+PKG_LICENSE_FILES:=
+
+PKG_BUILD_PARALLEL:=1
+
+include $(INCLUDE_DIR)/package.mk
+include $(INCLUDE_DIR)/cmake.mk
+
+define Package/umbim
+  SECTION:=net
+  CATEGORY:=Network
+  DEPENDS:=+libubox +kmod-usb-net +kmod-usb-net-cdc-mbim
+  TITLE:=Control utility for mobile broadband modems
+endef
+
+define Package/umbim/description
+  umbim is a command line tool for controlling mobile broadband modems using
+  the MBIM-protocol.
+endef
+
+TARGET_CFLAGS += \
+	-I$(STAGING_DIR)/usr/include -ffunction-sections -fdata-sections
+
+TARGET_LDFLAGS += -Wl,--gc-sections
+
+define Package/umbim/install
+	$(INSTALL_DIR) $(1)/sbin
+	$(INSTALL_BIN) $(PKG_BUILD_DIR)/umbim $(1)/sbin/
+	$(CP) ./files/* $(1)/
+endef
+
+$(eval $(call BuildPackage,umbim))
diff --git a/package/network/utils/umbim/files/lib/netifd/proto/mbim.sh b/package/network/utils/umbim/files/lib/netifd/proto/mbim.sh
new file mode 100755
index 0000000000..c93ba331df
--- /dev/null
+++ b/package/network/utils/umbim/files/lib/netifd/proto/mbim.sh
@@ -0,0 +1,147 @@
+#!/bin/sh
+
+. /lib/functions.sh
+. ../netifd-proto.sh
+init_proto "$@"
+
+#DBG=-v
+
+proto_mbim_init_config() {
+	proto_config_add_string "device:device"
+	proto_config_add_string apn
+	proto_config_add_string pincode
+	proto_config_add_string delay
+}
+
+proto_mbim_setup() {
+	local interface="$1"
+	local tid=2
+	local ret
+
+	local device apn pincode delay
+	json_get_vars device apn pincode delay
+
+	[ -n "$device" ] || {
+		logger -p daemon.err -t "mbim[$$]" "No control device specified"
+		proto_notify_error "$interface" NO_DEVICE
+		proto_block_restart "$interface"
+		return 1
+	}
+	[ -c "$device" ] || {
+		logger -p daemon.err -t "mbim[$$]" "The specified control device does not exist"
+		proto_notify_error "$interface" NO_DEVICE
+		proto_block_restart "$interface"
+		return 1
+	}
+	[ -n "$apn" ] || {
+		logger -p daemon.err -t "mbim[$$]" "No APN specified"
+		proto_notify_error "$interface" NO_APN
+		proto_block_restart "$interface"
+		return 1
+	}
+
+
+	[ -n "$delay" ] && sleep "$delay"
+
+	logger -p daemon.info -t "mbim[$$]" "Reading capabilities"
+	umbim $DBG -n -d $device caps || {
+		logger -p daemon.err -t "mbim[$$]" "Failed to read modem caps"
+		proto_notify_error "$interface" PIN_FAILED
+		proto_block_restart "$interface"
+		return 1
+	}
+	tid=$((tid + 1))
+
+	[ "$pincode" ] && {
+		logger -p daemon.info -t "mbim[$$]" "Sending pin"
+		umbim $DBG -n -t $tid -d $device unlock "$pincode" || {
+			logger -p daemon.err -t "mbim[$$]" "Unable to verify PIN"
+			proto_notify_error "$interface" PIN_FAILED
+			proto_block_restart "$interface"
+			return 1
+		}
+	}
+	tid=$((tid + 1))
+
+	logger -p daemon.info -t "mbim[$$]" "Checking pin"
+	umbim $DBG -n -t $tid -d $device pinstate || {
+		logger -p daemon.err -t "mbim[$$]" "PIN required"
+		proto_notify_error "$interface" PIN_FAILED
+		proto_block_restart "$interface"
+		return 1
+	}
+	tid=$((tid + 1))
+
+	logger -p daemon.info -t "mbim[$$]" "Checking subscriber"
+ 	umbim $DBG -n -t $tid -d $device subscriber || {
+		logger -p daemon.err -t "mbim[$$]" "Subscriber init failed"
+		proto_notify_error "$interface" NO_SUBSCRIBER
+		proto_block_restart "$interface"
+		return 1
+	}
+	tid=$((tid + 1))
+
+	logger -p daemon.info -t "mbim[$$]" "Register with network"
+  	umbim $DBG -n -t $tid -d $device registration || {
+		logger -p daemon.err -t "mbim[$$]" "Subscriber registration failed"
+		proto_notify_error "$interface" NO_REGISTRATION
+		proto_block_restart "$interface"
+		return 1
+	}
+	tid=$((tid + 1))
+
+	logger -p daemon.info -t "mbim[$$]" "Attach to network"
+   	umbim $DBG -n -t $tid -d $device attach || {
+		logger -p daemon.err -t "mbim[$$]" "Failed to attach to network"
+		proto_notify_error "$interface" ATTACH_FAILED
+		proto_block_restart "$interface"
+		return 1
+	}
+	tid=$((tid + 1))
+ 
+	logger -p daemon.info -t "mbim[$$]" "Connect to network"
+	while ! umbim $DBG -n -t $tid -d $device connect "$apn"; do
+		tid=$((tid + 1))
+		sleep 1;
+	done
+	tid=$((tid + 1))
+
+	uci_set_state network $interface tid "$tid"
+
+	logger -p daemon.info -t "mbim[$$]" "Connected, starting DHCP"
+	proto_init_update "*" 1
+	proto_send_update "$interface"
+
+	json_init
+	json_add_string name "${interface}_dhcp"
+	json_add_string ifname "@$interface"
+	json_add_string proto "dhcp"
+	json_close_object
+	ubus call network add_dynamic "$(json_dump)"
+
+	json_init
+	json_add_string name "${interface}_dhcpv6"
+	json_add_string ifname "@$interface"
+	json_add_string proto "dhcpv6"
+	json_close_object
+	ubus call network add_dynamic "$(json_dump)"
+}
+
+proto_mbim_teardown() {
+	local interface="$1"
+
+	local device
+	json_get_vars device
+	local tid=$(uci_get_state network $interface tid)
+
+	logger -p daemon.info -t "mbim[$$]" "Stopping network"
+	[ -n "$tid" ] && {
+		umbim $DBG -t$tid -d "$device" disconnect
+		uci_revert_state network $interface tid
+	}
+
+	proto_init_update "*" 0
+	proto_send_update "$interface"
+}
+
+add_protocol mbim
-- 
GitLab